## musescore 3.2.3+dfsg1

=== crashreporter/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2019 Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

QT5_WRAP_UI(ui_headers crashreporter.ui)

add_executable(mscore-crash-reporter
      ${ui_headers}
      ${_all_h_file}
      crashreporter.h
      crashreporter.cpp
      )

set_target_properties(
      mscore-crash-reporter
      PROPERTIES
      OUTPUT_NAME ${CRASHREPORTER_EXECUTABLE_NAME}
      )

target_include_directories(mscore-crash-reporter PRIVATE
      ${PROJECT_BINARY_DIR} # config.h
      )

target_link_libraries(mscore-crash-reporter ${QT_LIBRARIES})

install(TARGETS mscore-crash-reporter RUNTIME DESTINATION bin)

=== effects/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

if (APPLE)
      file(GLOB_RECURSE INCS "*.h")
else (APPLE)
      set(INCS "")
endif (APPLE)

QT5_ADD_RESOURCES (qrc_effects_files
     zita1/zita.qrc
     )

QT5_WRAP_UI (ui_headers
      compressor/compressor_gui.ui
      )

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_library (effects STATIC
      ${ui_headers}
      ${qrc_effects_files}
      ${_all_h_file}
      ${PCH}
      effect.cpp
      effectgui.cpp
      noeffect/noeffect.cpp
      noeffect/noeffectgui.h
      zita1/zita.cpp
      zita1/zitagui.cpp
      compressor/compressor.cpp
      compressor/compressorgui.cpp
      ${INCS}
      )

if (NOT MSVC)
   set_target_properties (
      effects
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch"
      )
else (NOT MSVC)
   set_target_properties (
      effects
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"
      )
endif (NOT MSVC)   

xcode_pch(effects all)

# Use MSVC pre-compiled headers
vstudio_pch( effects )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(effects mops1)
   ADD_DEPENDENCIES(effects mops2)
endif (NOT MSVC)

=== fluid/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#
#  Copyright (C) 2007 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

if (APPLE)
      file(GLOB_RECURSE INCS "*.h")
else (APPLE)
        set(INCS "")
endif (APPLE)

if (SOUNDFONT3)
      set(SF3_SRC sfont3.cpp)
endif (SOUNDFONT3)

QT5_WRAP_UI (fluidUi fluid_gui.ui)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_library (fluid STATIC
      ${_all_h_file}
      ${PCH}
      ${fluidUi}
      fluidgui.cpp
      dsp.cpp fluid.cpp voice.cpp chan.cpp sfont.cpp
      conv.cpp gen.cpp mod.cpp
      conv.h fluid.h fluidgui.h gen.h sfont.h voice.h
      ${SF3_SRC}
      ${INCS}
      )
if (NOT MSVC)
   set_target_properties (
      fluid
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch"
      )
else (NOT MSVC)
   set_target_properties (
      fluid
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"
      )
endif (NOT MSVC)   

xcode_pch(fluid all)

# Use MSVC pre-compiled headers
vstudio_pch( fluid )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(fluid mops1)
   ADD_DEPENDENCIES(fluid mops2)
endif (NOT MSVC)

=== libmscore/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2016 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

# MSVC does not depend on copying all.h to the binary directory
if (NOT MSVC)
   add_custom_command(
      OUTPUT ${PROJECT_BINARY_DIR}/all.h
      COMMAND ${CMAKE_COMMAND}
      ARGS -E copy ${PROJECT_SOURCE_DIR}/all.h ${PROJECT_BINARY_DIR}/all.h
      DEPENDS ${PROJECT_SOURCE_DIR}/all.h
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
      )
endif (NOT MSVC)

if (APPLE)
        file(GLOB_RECURSE INCS "*.h")
else (APPLE)
        set(INCS "")
endif (APPLE)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

include_directories(
      ${PROJECT_SOURCE_DIR}/thirdparty/dtl
      )

add_library (
      libmscore STATIC
      ${_all_h_file}
      ${INCS}

      types.h accidental.h ambitus.h arpeggio.h articulation.h audio.h bagpembell.h barline.h beam.h bend.h
      box.h bracket.h bracketItem.h breath.h bsp.h bsymbol.h chord.h chordline.h chordlist.h chordrest.h clef.h
      cleflist.h connector.h drumset.h dsp.h duration.h durationtype.h dynamic.h element.h
      elementmap.h excerpt.h fermata.h fifo.h figuredbass.h fingering.h fraction.h fret.h glissando.h groups.h hairpin.h
      harmony.h hook.h icon.h image.h imageStore.h iname.h input.h instrchange.h instrtemplate.h instrument.h interval.h
      jump.h key.h keylist.h keysig.h lasso.h layout.h layoutbreak.h ledgerline.h letring.h line.h location.h
      lyrics.h marker.h mcursor.h measure.h measurebase.h mscore.h mscoreview.h musescoreCore.h navigate.h note.h notedot.h
      noteevent.h noteline.h ossia.h ottava.h page.h palmmute.h part.h pedal.h pitch.h pitchspelling.h pitchvalue.h
      pos.h property.h range.h read206.h rehearsalmark.h repeat.h repeatlist.h rest.h revisions.h score.h scoreElement.h segment.h
      segmentlist.h select.h sequencer.h shadownote.h shape.h sig.h slur.h slurtie.h spacer.h spanner.h spannermap.h spatium.h
      staff.h stafflines.h staffstate.h stafftext.h stafftextbase.h stafftype.h stafftypechange.h stafftypelist.h stem.h
      stemslash.h stringdata.h style.h sym.h symbol.h synthesizerstate.h system.h systemdivider.h systemtext.h tempo.h
      tempotext.h text.h measurenumber.h textbase.h textedit.h textframe.h textline.h textlinebase.h tie.h tiemap.h timesig.h
      tremolo.h tremolobar.h trill.h tuplet.h tupletmap.h types.h undo.h utils.h velo.h vibrato.h volta.h xml.h

      segmentlist.cpp fingering.cpp accidental.cpp arpeggio.cpp
      fermata.cpp articulation.cpp barline.cpp beam.cpp bend.cpp box.cpp
      bracket.cpp breath.cpp bsp.cpp chord.cpp chordline.cpp
      chordlist.cpp chordrest.cpp clef.cpp cleflist.cpp
      drumset.cpp durationtype.cpp dynamic.cpp edit.cpp noteentry.cpp
      element.cpp excerpt.cpp
      fifo.cpp fret.cpp glissando.cpp hairpin.cpp
      harmony.cpp hook.cpp image.cpp iname.cpp instrchange.cpp
      instrtemplate.cpp instrument.cpp interval.cpp
      key.cpp keysig.cpp lasso.cpp
      layoutbreak.cpp layout.cpp line.cpp lyrics.cpp measurebase.cpp
      measure.cpp navigate.cpp note.cpp noteevent.cpp ottava.cpp
      page.cpp part.cpp pedal.cpp letring.cpp vibrato.cpp palmmute.cpp pitch.cpp pitchspelling.cpp
      rendermidi.cpp repeat.cpp repeatlist.cpp rest.cpp
      score.cpp segment.cpp select.cpp shadownote.cpp slur.cpp tie.cpp slurtie.cpp
      spacer.cpp spanner.cpp staff.cpp staffstate.cpp
      stafftextbase.cpp stafftext.cpp systemtext.cpp stafftype.cpp stem.cpp style.cpp symbol.cpp
      sym.cpp system.cpp stringdata.cpp tempotext.cpp text.cpp measurenumber.cpp textbase.cpp textedit.cpp
      textframe.cpp textline.cpp textlinebase.cpp timesig.cpp
      tremolobar.cpp tremolo.cpp trill.cpp tuplet.cpp
      utils.cpp velo.cpp volta.cpp xmlreader.cpp xmlwriter.cpp mscore.cpp
      undo.cpp cmd.cpp scorefile.cpp revisions.cpp
      check.cpp input.cpp icon.cpp ossia.cpp
      tempo.cpp sig.cpp pos.cpp duration.cpp
      figuredbass.cpp rehearsalmark.cpp transpose.cpp
      property.cpp range.cpp elementmap.cpp notedot.cpp imageStore.cpp
      audio.cpp splitMeasure.cpp joinMeasure.cpp
      paste.cpp
      bsymbol.cpp marker.cpp jump.cpp stemslash.cpp ledgerline.cpp
      synthesizerstate.cpp mcursor.cpp groups.cpp mscoreview.cpp
      noteline.cpp spannermap.cpp
      bagpembell.cpp ambitus.cpp keylist.cpp scoreElement.cpp
      shape.cpp systemdivider.cpp midimapping.cpp stafflines.cpp
      sticking.cpp
      read114.cpp
      read206.cpp
      read301.cpp stafftypelist.cpp stafftypechange.cpp
      bracketItem.cpp
      lyricsline.cpp
      layoutlinear.cpp
      connector.cpp location.cpp skyline.cpp
      scorediff.cpp
      unrollrepeats.cpp
      )

##
## Code coverage. Only affects DEBUG builds.
##

set(COVERAGE_OPTIONS "")
if (NOT APPLE AND NOT MINGW AND NOT MSVC AND CMAKE_BUILD_TYPE MATCHES "DEBUG")
   if (COVERAGE)
      set(COVERAGE_OPTIONS "-O0 --coverage")
      set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE 1)
      target_link_libraries(libmscore gcov)
   endif (COVERAGE)
endif (NOT APPLE AND NOT MINGW AND NOT MSVC AND CMAKE_BUILD_TYPE MATCHES "DEBUG")



if (NOT MSVC)
   set_target_properties (
      libmscore
      PROPERTIES
         COMPILE_FLAGS "-g ${PCH_INCLUDE} -Wall -Wextra -Winvalid-pch -Woverloaded-virtual ${COVERAGE_OPTIONS}"
      )
else (NOT MSVC)
   set_target_properties (
      libmscore
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"
      )
endif (NOT MSVC)

xcode_pch(libmscore all)

# Use MSVC pre-compiled headers
vstudio_pch( libmscore )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(libmscore mops1)
   ADD_DEPENDENCIES(libmscore mops2)
endif (NOT MSVC)

=== miditools/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENCE.GPL
#=============================================================================

add_executable (smf2xml smf2xml.cpp xmlwriter.cpp midifile.cpp)

if (NOT MSVC)
   set_target_properties(smf2xml
      PROPERTIES COMPILE_FLAGS "-g -Wall -Wextra"
      )
else (NOT MSVC)
   set_target_properties (smf2xml
      PROPERTIES COMPILE_FLAGS ""
      )
endif (NOT MSVC)   

target_link_libraries(smf2xml
      ${QT_LIBRARIES}
      )

add_executable (xml2smf xml2smf.cpp xmlreader.cpp midifile.cpp)

if (NOT MSVC)
   set_target_properties (
      xml2smf
      PROPERTIES COMPILE_FLAGS "-g -Wall -Wextra"
      )
else (NOT MSVC)
   set_target_properties (
      xml2smf
      PROPERTIES COMPILE_FLAGS ""
      )
endif (NOT MSVC)   

target_link_libraries(xml2smf
      ${QT_LIBRARIES}
      )

=== mscore/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Linux Music Score Editor
#
#  Copyright (C) 2002-2016 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

function(prepend_to_list_items # prepend a string to each item in list
  LIST_INV # input list variable
  STRING # the string to prepend to each list item
  LIST_OUTV # input list variable
  )
  set(LIST_IN "${${LIST_INV}}")
  set(LIST_OUT "") # empty list
  foreach(ITEM IN LISTS LIST_IN)
    list(APPEND LIST_OUT "${STRING}${ITEM}")
  endforeach(ITEM)
  set("${LIST_OUTV}" "${LIST_OUT}" PARENT_SCOPE)
endfunction(prepend_to_list_items)

add_subdirectory(widgets)
prepend_to_list_items(WIDGETS_SOURCE_FILES "widgets/" WIDGETS_SOURCE_FILES)

# This is not needed for MSVC compilation
if (NOT MSVC)
   include (${PROJECT_SOURCE_DIR}/build/gch.cmake)
endif (NOT MSVC)
include (${PROJECT_SOURCE_DIR}/build/CopyFilesMacros.cmake)

SET_SOURCE_FILES_PROPERTIES(revision.h PROPERTIES GENERATED TRUE)

include_directories(
      ${CMAKE_CURRENT_BINARY_DIR}
      ${PROJECT_SOURCE_DIR}
      ${PROJECT_SOURCE_DIR}/thirdparty
      ${QTSINGLEAPPLICATION_INCLUDE_DIRS}
      )

if (SCRIPT_INTERFACE)
      set (SCRIPT_FILES
            plugin/pluginCreator.h plugin/pluginManager.h plugin/qmledit.h
            plugin/qmlplugin.h plugin/qmlpluginengine.h
            plugin/api/qmlpluginapi.h plugin/api/cursor.h plugin/api/scoreelement.h plugin/api/elements.h
            plugin/api/part.h
            plugin/api/score.h
            plugin/api/fraction.h
            plugin/api/excerpt.h
            plugin/api/util.h

            plugin/api/enums.cpp
            plugin/mscorePlugins.cpp plugin/pluginCreator.cpp plugin/pluginManager.cpp plugin/qmledit.cpp
            plugin/qmlplugin.cpp plugin/qmlpluginengine.cpp
            plugin/api/qmlpluginapi.cpp plugin/api/cursor.cpp plugin/api/scoreelement.cpp plugin/api/elements.cpp
            plugin/api/score.cpp
            plugin/api/excerpt.cpp
            plugin/api/util.cpp
            )

      set (SCRIPT_UI
            plugin/pluginCreator.ui plugin/pluginManager.ui
            )
endif (SCRIPT_INTERFACE)

QT5_WRAP_UI (ui_headers
      insertmeasuresdialog.ui editinstrument.ui editstyle.ui instrdialog.ui instrwidget.ui
      measuresdialog.ui pagesettings.ui mixer.ui mixertrackchannel.ui mixertrackpart.ui mixerdetails.ui parteditbase.ui
      playpanel.ui prefsdialog.ui measureproperties.ui
      textpalette.ui  timedialog.ui symboldialog.ui  shortcutcapturedialog.ui  editdrumset.ui
      editstaff.ui timesigproperties.ui
      instrwizard.ui timesigwizard.ui newwizard.ui aboutbox.ui aboutmusicxmlbox.ui
      transposedialog.ui excerptsdialog.ui  stafftext.ui tupletdialog.ui
      articulation.ui metaedit.ui palette.ui selectdialog.ui selectnotedialog.ui
      synthcontrol.ui splitstaff.ui cellproperties.ui keyedit.ui selectinstr.ui
      fretdprops.ui editstafftype.ui sectionbreak.ui  bend.ui tremolobar.ui
      editpitch.ui editstringdata.ui editraster.ui mediadialog.ui albummanager.ui layer.ui
      omrpanel.ui masterpalette.ui harmonyedit.ui pathlistdialog.ui
      note_groups.ui resourceManager.ui stafftypetemplates.ui
      startcenter.ui scorePreview.ui scoreBrowser.ui templateBrowser.ui
      logindialog.ui uploadscoredialog.ui breaksdialog.ui
      toolbarEditor.ui workspacedialog.ui

      importmidi/importmidi_panel.ui

      scorecmp/scorecmp_tool.ui
      script/script_recorder.ui

      debugger/barline.ui
      debugger/harmony.ui
      debugger/box.ui
      debugger/keysig.ui
      debugger/rest.ui
      debugger/articulationbase.ui
      debugger/accidental.ui
      debugger/clef.ui
      debugger/slursegment.ui
      debugger/tiesegment.ui
      debugger/spanner.ui
      debugger/tremolo.ui
      debugger/beam.ui
      debugger/lyrics.ui
      debugger/linesegment.ui
      debugger/textline.ui
      debugger/line.ui
      debugger/slurtie.ui
      debugger/tie.ui
      debugger/tuplet.ui
      debugger/dynamic.ui
      debugger/hairpin.ui
      debugger/chord.ui
      debugger/chordrest.ui
      debugger/segment.ui
      debugger/measure.ui
      debugger/element.ui
      debugger/debugger.ui
      debugger/note.ui
      debugger/page.ui
      debugger/text.ui
      debugger/stem.ui
      debugger/system.ui
      debugger/timesig.ui
      debugger/bracket.ui

      inspector/inspector_element.ui
      inspector/inspector_vbox.ui
      inspector/inspector_tbox.ui
      inspector/inspector_articulation.ui
      inspector/inspector_spacer.ui
      inspector/inspector_hbox.ui
      inspector/inspector_segment.ui
      inspector/inspector_beam.ui
      inspector/inspector_note.ui
      inspector/inspector_notedot.ui
      inspector/inspector_rest.ui
      inspector/inspector_chord.ui
      inspector/inspector_group_element.ui
      inspector/inspector_image.ui
      inspector/inspector_harmony.ui
      inspector/inspector_lasso.ui
      inspector/inspector_volta.ui
      inspector/inspector_ottava.ui
      inspector/inspector_trill.ui
      inspector/inspector_vibrato.ui
      inspector/inspector_hairpin.ui
      inspector/inspector_jump.ui
      inspector/inspector_marker.ui
      inspector/inspector_glissando.ui
      inspector/inspector_clef.ui
      inspector/inspector_timesig.ui
      inspector/inspector_keysig.ui
      inspector/inspector_barline.ui
      inspector/inspector_tuplet.ui
      inspector/inspector_accidental.ui
      inspector/inspector_tempotext.ui
      inspector/inspector_dynamic.ui
      inspector/inspector_instrchange.ui
      inspector/inspector_lyric.ui
      inspector/inspector_line.ui
      inspector/inspector_textline.ui
      inspector/inspector_letring.ui
      inspector/inspector_palmmute.ui
      inspector/inspector_pedal.ui
      inspector/inspector_textlinebase.ui
      inspector/inspector_slur.ui
      inspector/inspector_text.ui
      inspector/inspector_stafftext.ui
      inspector/inspector_ambitus.ui
      inspector/inspector_empty.ui
      inspector/inspector_fret.ui
      inspector/inspector_break.ui
      inspector/inspector_stafftypechange.ui
      inspector/inspector_bend.ui
      inspector/inspector_arpeggio.ui
      inspector/inspector_tremolo.ui
      inspector/inspector_tremolobar.ui
      inspector/inspector_caesura.ui
      inspector/inspector_bracket.ui
      inspector/inspector_iname.ui
      inspector/inspector_fingering.ui
      inspector/inspector_frametext.ui
      inspector/inspector_fermata.ui
      inspector/align_select.ui
      inspector/font_style_select.ui
      inspector/offset_select.ui
      inspector/scale_select.ui
      inspector/size_select.ui
      inspector/inspector_stem.ui
      ${SCRIPT_UI}
      )

if (APPLE)
      QT5_ADD_RESOURCES (qrc_files musescore.qrc musescorefonts-Mac.qrc shortcut-Mac.qrc)
else (APPLE)
      QT5_ADD_RESOURCES (qrc_files musescore.qrc
            musescorefonts-MScore.qrc
            musescorefonts-Gootville.qrc
            musescorefonts-Bravura.qrc
            musescorefonts-MuseJazz.qrc
            musescorefonts-FreeSerif.qrc
            musescorefonts-Free.qrc
            shortcut.qrc)
endif (APPLE)


set (AUDIO "")
if (MINGW)
      set (resource_file ${PROJECT_BINARY_DIR}/resfile.o)
endif (MINGW)
if (MSVC)
      # MSVC recognizes a *.rc file and will invoke the resource compiler to link it
      set (resource_file ${PROJECT_SOURCE_DIR}/mscore/data/mscore.rc)
endif ( MSVC )
if ( NOT MINGW AND NOT MSVC )
      if (USE_ALSA)
            set (AUDIO ${AUDIO} alsa.cpp)
      endif (USE_ALSA)
endif ( NOT MINGW AND NOT MSVC )

if (USE_PORTAUDIO)
      set (AUDIO ${AUDIO} pa.cpp)
endif (USE_PORTAUDIO)

if (USE_PULSEAUDIO)
      set (AUDIO ${AUDIO} pulseaudio.cpp)
endif (USE_PULSEAUDIO)

if (USE_PORTMIDI)
      set (AUDIO ${AUDIO} pm.cpp)
endif (USE_PORTMIDI)

if (USE_LAME)
      set (AUDIO ${AUDIO} exportmp3.cpp)
endif (USE_LAME)

if (USE_JACK)
      set (AUDIO ${AUDIO} jackaudio.cpp jackweakapi.cpp)
endif (USE_JACK)

if (USE_ALSA OR USE_PORTMIDI)
      set (AUDIO ${AUDIO} mididriver.cpp)
endif (USE_ALSA OR USE_PORTMIDI)

if (${CMAKE_SYSTEM} MATCHES "GNU-0.3")
      # Include some cmake support file
      INCLUDE (Platform/GNU)
      set ( USE_ALSA 0 )
      set ( USE_PORTMIDI 0 )
endif (${CMAKE_SYSTEM} MATCHES "GNU-0.3")

if (${CMAKE_SYSTEM} MATCHES "kFreeBSD")
      # Include some cmake support file
      INCLUDE (Platform/kFreeBSD)
      set ( USE_ALSA 0 )
      set ( USE_PORTMIDI 0 )
endif (${CMAKE_SYSTEM} MATCHES "kFreeBSD")

if (APPLE)
      set (ExecutableName mscore MACOSX_BUNDLE)
      set (MACOSX_BUNDLE_ICON_FILE      mscore.icns)
      set (MACOSX_BUNDLE_GUI_IDENTIFIER org.musescore.MuseScore)
      set (MACOSX_BUNDLE_LONG_VERSION_STRING ${MUSESCORE_VERSION_FULL})
      set (MACOSX_BUNDLE_BUNDLE_NAME MuseScore)
      set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${MUSESCORE_VERSION})
      set (MACOSX_BUNDLE_BUNDLE_VERSION ${MUSESCORE_VERSION_FULL})
      if(CMAKE_BUILD_NUMBER)
        set (MACOSX_BUNDLE_SHORT_VERSION_STRING ${MUSESCORE_VERSION_FULL}.${CMAKE_BUILD_NUMBER})
        set (MACOSX_BUNDLE_BUNDLE_VERSION ${MUSESCORE_VERSION_FULL}.${CMAKE_BUILD_NUMBER})
      endif(CMAKE_BUILD_NUMBER)
      set (MACOSX_BUNDLE_COPYRIGHT musescore.org)
else (APPLE)
      set (ExecutableName mscore)
endif (APPLE)

if (OMR)
      set(OMR_FILES omrpanel.cpp)
endif (OMR)

if (APPLE)
      file(GLOB_RECURSE INCS "*.h")
      set(COCOABRIDGE "macos/cocoabridge.mm")
      if (SPARKLE_FOUND)
            set(MAC_SPARKLE_FILES "macos/SparkleAutoUpdater.mm")
      endif(SPARKLE_FOUND)
else (APPLE)
      set(INCS "")
      set(COCOABRIDGE "")
      set(MAC_SPARKLE_FILES  "")
endif (APPLE)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_executable ( ${ExecutableName}
      ${qrc_files}
      ${ui_headers}
      ${_all_h_file}
      ${PCH}
      ${resource_file}
      ${INCS}

      abstractdialog.h accessibletoolbutton.h albummanager.h
      alsa.h alsamidi.h analyse.h articulationprop.h bb.h
      bendcanvas.h bendproperties.h breaksdialog.h capella.h
      chordview.h click.h continuouspanel.h downloadUtils.h
      driver.h drumroll.h drumtools.h drumview.h editdrumset.h
      editinstrument.h editpitch.h editraster.h editstaff.h
      editstafftype.h editstringdata.h editstyle.h enableplayforwidget.h
      exampleview.h excerptsdialog.h exportmidi.h exportmp3.h extension.h
      file.h fotomode.h fretcanvas.h fretproperties.h globals.h greendotbutton.h
      harmonycanvas.h harmonyedit.h help.h helpBrowser.h icons.h importgtp.h importmxml.h
      importmxmllogger.h importmxmlnoteduration.h importmxmlnotepitch.h importmxmlpass1.h
      importmxmlpass2.h importptb.h importxmlfirstpass.h instrdialog.h instrwidget.h jackaudio.h
      keycanvas.h keyedit.h layer.h licence.h
      logindialog.h network/loginmanager.h network/loginmanager_p.h
      magbox.h masterpalette.h
      measureproperties.h mediadialog.h metaedit.h miconengine.h mididriver.h
      mixer.h mixertrack.h mixertrackchannel.h mixertrackgroup.h mixertrackitem.h mixertrackpart.h mixerdetails.h musedata.h
      musescore.h musicxml.h musicxmlfonthandler.h musicxmlsupport.h navigator.h newwizard.h noteGroups.h

=== omr/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  Copyright (C) 2002-2006 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

include_directories(
      ${PROJECT_SOURCE_DIR}
      ${PROJECT_BINARY_DIR}
      )

if (OCR)
      set (OCR_SRC ocr.cpp)
endif (OCR)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_library (
      omr STATIC
      ${_all_h_file}
      ${PCH}
      omrview.cpp pdf.cpp omrpage.cpp
      skew.cpp utils.cpp
      omr.cpp pattern.cpp importpdf.cpp
      ${OCR_SRC}
      )

if (NOT MSVC)
   set_target_properties (
      omr
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch -Wno-unused-private-field"
      )
else (NOT MSVC)
   set_target_properties (
      omr
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"    # TODO: Add disabling of unused private field warning?
      )
endif (NOT MSVC)   

xcode_pch(omr all)

# Use MSVC pre-compiled headers
vstudio_pch( omr )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(omr mops1)
   ADD_DEPENDENCIES(omr mops2)
endif (NOT MSVC)

=== rdoc/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2011 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

add_custom_target(referenceDocumentation
      ALL
      DEPENDS en/doc.html de/doc.html en/doc.qhp de/doc.qhp
      )

add_custom_command(TARGET referenceDocumentation
      POST_BUILD
      COMMAND Qt5::qcollectiongenerator ${PROJECT_SOURCE_DIR}/rdoc/en/doc.qhcp -o doc_en.qhc
      COMMAND Qt5::qcollectiongenerator ${PROJECT_SOURCE_DIR}/rdoc/de/doc.qhcp -o doc_de.qhc
      )

install(FILES
      ${PROJECT_BINARY_DIR}/rdoc/doc_en.qhc
      ${PROJECT_BINARY_DIR}/rdoc/doc_de.qhc
  DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME}manual)

=== share/CMakeLists.txt ===
#=============================================================================
#  Mscore
#  Linux Music Score Editor
#
#  Copyright (C) 2002-2006 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

subdirs(templates wallpaper locale styles sound manual
   workspaces instruments tours)

install (DIRECTORY
      plugins
      DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME}
      PATTERN ".*" EXCLUDE
      )

=== synthesizer/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

if (APPLE)
      file(GLOB_RECURSE INCS "*.h")
else (APPLE)
      set(INCS "")
endif (APPLE)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_library (synthesizer STATIC
      ${_all_h_file}
      ${PCH}
      msynthesizer.cpp
      event.cpp
      synthesizergui.cpp
      ${INCS}
      )
if (NOT MSVC)
   set_target_properties (
      synthesizer
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch"
      )
else (NOT MSVC)
   set_target_properties (
      synthesizer
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"
      )
endif (NOT MSVC)   

xcode_pch(synthesizer all)

# Use MSVC pre-compiled headers
vstudio_pch( synthesizer )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(synthesizer mops1)
   ADD_DEPENDENCIES(synthesizer mops2)
endif (NOT MSVC)

=== zerberus/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENCE.GPL
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

QT5_WRAP_UI (zerberusUi zerberus_gui.ui)

if (NOT MSVC)
   set(_all_h_file "${PROJECT_BINARY_DIR}/all.h")
else (NOT MSVC)
   set(_all_h_file "${PROJECT_SOURCE_DIR}/all.h")
endif (NOT MSVC)

add_library (zerberus STATIC
      ${zerberusUi}
      channel.cpp
      filter.cpp
      instrument.cpp
      sfz.cpp
      voice.cpp
      zerberus.cpp
      zone.cpp
      zerberusgui.cpp
      ${_all_h_file}
      ${PCH}
      ${INCS}
      )

if (NOT MSVC)
   set_target_properties (
      zerberus
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch"
      )
else (NOT MSVC)
   set_target_properties (
      zerberus
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE}"
      )
endif (NOT MSVC)   

xcode_pch(zerberus all)

# Use MSVC pre-compiled headers
vstudio_pch( zerberus )

# MSVC does not depend on mops1 & mops2 for PCH
if (NOT MSVC)
   ADD_DEPENDENCIES(zerberus mops1)
   ADD_DEPENDENCIES(zerberus mops2)
endif (NOT MSVC)

=== mtest/guitarpro/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

set(TARGET tst_guitarpro)

include(${PROJECT_SOURCE_DIR}/mtest/cmake.inc)

=== debian/changelog ===
musescore (3.2.3+dfsg1-5) unstable; urgency=high

  * Merge musescore2 (2.3.2+dfsg3-8) wtf; urgency=low
    - Bump Policy (nothing relevant), debhelper
    - Remove dependencies on Qt SQL library which are unneeded
    - Fix DEP 5 format: repacking notice must be in Source, not a Comment
    - Update patches (forwarding information / releases fixed)
    - Drop home-grown umask fixup code, dh does this nowadays
    - Use dh’s new execute_{before,after}_* overrides
    - Work around #796257 to fix Debian reproducible builds
    - Don’t show irrelevant Qt5 deprecation warnings; upstream’s to fix
    - Forward and apply fixes by lintian
  * Add some patches from upstream:
    - Fix warning when loading custom workspaces
    - Allow building against Qt 5.14 (Closes: #964641)
    - Fix rendering of emboldened fonts
    - Numerous crash, playback, layout and other bugfixes
  * Update copyright info (Debian and patches from upstream/submissions)
    - a new CLA seems to be used since 2019…
  * SMuFL: fix typo

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 30 Jul 2020 20:24:17 +0200

musescore (3.2.3+dfsg1-4) unstable; urgency=medium

  * Apply workaround for broken directory bookmarks in file dialogue
  * (Yes I know 3.3’s out, I will be packaging it shortly)
  * Merge musescore2 (2.3.2+dfsg3-7) wtf; urgency=low
  * Upload to sid again without the revert restriking patch
  * Add new features from 3.2 to the package description

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 10 Nov 2019 22:54:07 +0100

musescore (3.2.3+dfsg1-3exp1) experimental; urgency=medium

  * Upload to experimental, again with the revert restriking patch
  * Use the Debian packaging of freefont, do not bundle it

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 30 Oct 2019 15:37:20 +0100

musescore (3.2.3+dfsg1-3) unstable; urgency=high

  * Fix crash on reading preferences files containing unrecognised
    entries (such as these from a later otherwise compatible version)
  * Update lintian override: a false positive is no longer present

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 30 Oct 2019 15:36:22 +0100

musescore (3.2.3+dfsg1-2exp1) experimental; urgency=low

  * Upload to experimental, again with the revert restriking patch

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 30 Sep 2019 02:32:24 +0200

musescore (3.2.3+dfsg1-2) unstable; urgency=low

  * Upload to unstable, again without the restriking patch
  * Merge musescore (3.2.3+dfsg1-1exp1) experimental; urgency=low
    - pull another post-release bugfix from upstream
  * Set umask 022 for reproducibility
  * Merge musescore2 (2.3.2+dfsg3-6) wtf; urgency=low
    - updates d/copyright with more historic info + formatting
    - modernising and correcing packaging
    - runs test in UTF-8 locale, lile build
    - add -g3 to optdbg builds
    - Policy 4.4.1 (no changes)
  * Fix misspelt translation

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 30 Sep 2019 01:18:56 +0200

musescore (3.2.3+dfsg1-1exp1) experimental; urgency=low

  * Upload to experimental, again with the revert restriking patch
  * Pull another post-release bugfix from upstream

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jul 2019 18:57:24 +0200

musescore (3.2.3+dfsg1-1) unstable; urgency=low

  * Fix About when build number is empty (cosmetic)
  * Merge musescore2 (2.3.2+dfsg3-5) wtf; urgency=low
  * New upstream release
  * Upload to unstable, with the revert restriking patch disabled
  * Fix building with disabled plugins (needed to build on stretch)
  * Small cosmetic fix for About dialogue and --long-version

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jul 2019 03:22:28 +0200

musescore (3.2.2+dfsg1-1) experimental; urgency=medium

  * New upstream release
  * Merge musescore-snapshot (3.1+dfsg1-1) experimental; urgency=medium
  * Drop merged patches, update patches
  * Merge musescore2 (2.3.2+dfsg3-4) wtf; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 04 Jul 2019 23:55:01 +0200

musescore-snapshot (3.1+dfsg1-1) experimental; urgency=medium

  * New upstream release, repackaged as snapshot for integration work
  * Apply four post-release bugfixes: three from master, one from the
    musescore.com backend branch that’s not… yet(?) there
  * Update description with new features from 3.0 and 3.1
  * Merge musescore2 (2.3.2+dfsg3-2) wtf; urgency=medium
  * Supplement the AppStream metadata with the new release
  * Fix charset used by local plugin docs
  * Register plugin documentation with doc-base
  * Note known bug https://musescore.org/en/node/290147

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 03 Jun 2019 23:42:38 +0200

musescore-snapshot (3.1~pre20190412+dfsg1-1) experimental; urgency=low

  * New upstream snapshot “v3.1beta”
  * Merge musescore (3.0.5+dfsg1-2) experimental; urgency=low
  * Generate and install full plugin documentation locally
  * Merge musescore (3.0.5+dfsg1-3) experimental; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 19 Apr 2019 22:24:42 +0200

musescore-snapshot (3.1~pre20190227+dfsg1-1) experimental; urgency=low

  * Revert to tracking “git master” snapshots now 3.0.x was branched
  * New upstream snapshot; drop applied and refresh remaining patches

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 27 Feb 2019 21:01:07 +0100

musescore (3.0.5+dfsg1-3) experimental; urgency=low

  * Merge musescore (2.3.2+dfsg2-6) unstable; urgency=medium
  * Mark more patches as applied upstream
  * Adopt package description marker distinguishing from castling branch
  * Update AppData PR patch
  * Add a few crash fix patches until 3.1 is out
  * Clarify the Qt 5.7 patch use in stretch-backports-sloppy *only*
  * Apply recommended settings of debhelper 12

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 04 May 2019 01:55:53 +0200

musescore (3.0.5+dfsg1-2) experimental; urgency=low

  * Merge musescore (2.3.2+dfsg2-5) unstable; urgency=medium
  * Update patches and pull three new bugfix patches from upstream
  * Stop suggesting old tiny soundfonts: we pull in a suitable, large


=== debian/control ===
Source: musescore
Section: sound
Priority: optional
Maintainer: Thorsten Glaser <tg@mirbsd.de>
Homepage: https://musescore.org/en
Build-Depends: debhelper-compat (= 13),
# # for the tests
# imagemagick,
  mksh,
  xauth,
  xvfb,
# # testsuite and runtime
  desktop-file-utils,
  fonts-freefont-ttf,
  libmp3lame0,
  musescore-general-soundfont-small | musescore-compatible-soundfont,
  qml-module-qtquick-controls,
  qml-module-qtquick-dialogs,
  qml-module-qtquick-layouts,
  qml-module-qtquick2,
  shared-mime-info,
  xdg-utils,
# # build
  cmake,
  doxygen,
  g++ (>= 4:4.8),
  graphviz,
  libasound2-dev,
  libfreetype6-dev (>= 2.5.2),
  libjack-dev,
  libmp3lame-dev,
  libpoppler-qt5-dev,
  libportmidi-dev [linux-any],
  libpulse-dev,
  libqt5opengl5-dev,
  libqt5svg5-dev,
  libqt5xmlpatterns5-dev,
  libsndfile1-dev (>= 1.0.25),
  lsb-release,
  portaudio19-dev,
  qtbase5-dev,
  qtdeclarative5-dev (>= 5.8),
  qtscript5-dev,
  qttools5-dev,
  qttools5-dev-tools,
  zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
VCS-git: https://evolvis.org/anonscm/git/alioth/musescore.git -b master
VCS-Browser: https://evolvis.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=alioth/musescore.git;a=shortlog;h=refs/heads/master

Package: musescore3-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 musescore-general-soundfont-small | musescore-compatible-soundfont
Description: MuseScore 3 (music composition and notation) shared files
 Demonstration scores and templates, styles, localisations, some
 plugins for MuseScore, the Open Source (GNU GPL) cross-platform
 multi-lingual music notation software.
 .
 In contrast to earlier versions, no sound font is provided by
 default, but the Depends ensure a suitable one is installed,
 normally the compact, full orchestral and band sound, one that
 is shipped with MuseScore from version 2.2 onwards, or its more
 limited 2.1 counterpart fluidr3mono-gm-soundfont. In general,
 any soundfont that Provides musescore-compatible-soundfont will
 be acceptable; if you installed multiple, run the following
 command to configure the default MuseScore soundfont (select
 “0” to ensure that the highest-quality soundfont is used):
 .
 $ sudo update-alternatives --config MuseScore_General.sf3

Package: musescore3
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
  desktop-file-utils,
  fonts-freefont-ttf,
  qml-module-qtquick-controls,
  qml-module-qtquick-dialogs,
  qml-module-qtquick-layouts,
  qml-module-qtquick2,
  shared-mime-info,
  xdg-utils,
# # dependent on MSCORE_INSTALL_SUFFIX from debian/rules
# # and MUSESCORE_VERSION_{MAJOR,MINOR} from CMakeLists.txt
  musescore3-common (>> 3.2~), musescore3-common (<< 3.3~)
Recommends: libmp3lame0
Suggests: pulseaudio-utils
Description: cross-platform multi-lingual music composition and notation
 MuseScore is an Open Source (GNU GPL) music notation software that runs
 on all platforms supported by Qt5 (GNU/Linux, MacOS X, Windows), and is
 available in over forty different languages. It features an easy to use
 WYSIWYG editor with audio score playback for results that look and sound
 beautiful, rivaling commercial offerings like Finale and Sibelius.
 .
 Create, play back and print sheet music for free. Features include:
  - easy-to-use and customisable interface
  - optional dark theme (to focus on the score)
  - tours for first-time and returning users
  - albums combining multiple scores
  - unlimited score length
  - unlimited number of staves per system
  - up to four independent voices per staff
  - score creation wizard and templates
  - easy and fast note entry with a (PC) keyboard, the mouse, including
    an on-screen virtual (piano) keyboard, or MIDI (step-time, real-time)
  - timewise input (moving subsequent notes/rests), also for unmetered music
  - half-time and double-time paste commands for copy/paste
  - continuous view: focus on the content, scrolling by as an endless
    ribbon, undistracted by line breaks or page breaks; switch to page
    view to polish up for printing
  - timeline view
  - automatic part extraction (by staves or voices) and transposition
  - advanced transposition: transpose a selected passage to any key,
    or by any interval — or even transpose diatonically within the same key
  - repeats, including segnos, codas, measure repeats, advanced repeats;
    linearisation command to expand repeats
  - dynamics, articulations and other expression markings
  - playback support for almost all notation elements
  - custom text markings
  - style rules that apply to the whole score at once
  - automatic placement system (smart layout), now even more flexible
  - lyrics
  - chord symbols
  - Jazz notation, including lead sheets and slash notation
  - swing and shuffle playback
  - integrated sequencer and two software synthesisers (FluidSynth for
    SF2/SF3, Zerberus for SFZ), which also can use third-party soundfonts
  - single-note dynamics
  - mixer for instrument levels and effects
  - mixing and panning for individual parts
  - percussion notation
  - sticking (“fingering” for drummers)
  - early music notation
  - cross-staff beaming
  - import of graphics
  - custom key signatures
  - additive time signatures
  - system dividers
  - user-defined score styles
  - cutaway staves
  - pianoroll editor, edit playback parameters of each note individually
  - score comparison tool
  - and much more…
 .
 Choir features:
  - powerful lyrics copy and paste tools
  - implode/explode: combine up to four voices on one staff,
    then separate to individual staves
  - hide empty vocal staves, such as in a piano intro
  - figured bass for historical notation
  - smart lyrics: unlimited verses, with notes and staves automatically
    spaced, and verse numbers automatically aligned
  - voice leading checker: download the Check Harmony Rules proofreading
    plugin to check for errors in your part writing, according to
    standard rules
  - part mixer: mute, solo, or change volume of staves to learn
    individual lines — settings even apply to MP3 export
 .
 Piano features:
  - support for solo + piano (add small staff with different instrument)
  - support for cadenzas (smaller notes and variable length measures)
  - complete notation: pedaling, fingering, cross-staff beaming — you
    name it; everything needed to write piano sheet music is here
 .
 Guitar features:
  - bends, fingerings, and other common guitar notations supported
  - add/remove linked staves any time; enter notes on either standard
    (pitched five-line) or TAB staff
  - percussion/drumset also included
  - templates include guitar, tablature, guitar+tablature, rock/pop band
  - complete tablature: multiple tab styles available — from note symbols
    outside the staff to upside-down strings — and linked standard/tab
    staff pairs
  - Guitar Pro import: MuseScore can now open files from Guitar Pro, so
    you can easily migrate over. Import filters are improving with every
    release; GP3, GP4, GP5, GP6, GTP, GPX are currently supported.
  - Fretboard diagrams: 21 default chords for every key, and a powerful
    editor to create your own — with barre, fret position, and any number
    of strings
  - multiple or differently shaped dots per string; partial and multiple
    barres; ability to not show nut; customisable string/fret distance;
    chord symbols for diagrams and saving those to the palette; etc.
  - beyond guitar: banjo, mandolin, ukulele, oud; custom string tunings;
    even historical lute tablature: MuseScore does them all.
 .
 Orchestral features:
  - templates for common instrumentations
  - custom linked parts (e.g. create choral score from orchestra+chorus):
    any change you make to the content of any part is immediately
    reflected in the full score — and vice versa
  - powerful style controls: edit the formatting of parts and score
    independently — or apply the same style to all parts with one click
  - one-click transposition: instantly switch between transposed and
    concert pitch: sounding pitches stay the same while the written notes
    change
 .
 Jazz features:
  - templates for Jazz Lead Sheet, Big Band and Jazz Combo
  - real “handwritten” Book-style jazz font for text and chord symbols
  - formatting tools include adding line breaks every X measures
  - instantly switch between transposed and concert pitch
  - intelligent chord symbol: chord names are automatically formatted
    when you finish typing — plus, they transpose with the notes
  - easy slashes: commands to fill bars with slashes — and to turn notes
    into rhythmic slashes, and even accent notation above the staff
 .
 Marching ensembles features (needs the MDL extension):
  - marching band, indoor percussion, front ensemble, drumline and drum
    corps (even G bugles); no setup or configuration — select a template,
    start writing
 .
 Band features:
  - diverse templates: concert band, brass band, marching band, battery
    and pit percussion — ready out-of-the-box (plus big band for jazz)
  - custom linked parts: you can even keep a drumline score linked to a
    full marching band score and to individual percussion parts
 .
 Most elements in MuseScore are laid out automatically on a “virtual note
 sheet”, with a near professional-quality layout engine, but can also be
 positioned manually, giving you total control of every score element’s
 position. The capabilities of MuseScore can be extended via plugins and
 extensions, and the growing repository on musescore.org contains many
 plugins submitted by users and an active development team.
 .
 MuseScore includes a set of sounds that reproduce common instruments (as
 defined by General MIDI) without taking up a lot of disk space or memory
 providing full orchestral and band sounds (with the Drumline extension
 installed this includes marching percussion). The general (non-Drumline)
 sound font is available as musescore-general-soundfont Debian package,
 if you wish to reuse it with other synthesisers.) You can also load any
 sound font you prefer for a wider variety of sounds or for more realism.
 .
 MuseScore can import and export MIDI and MusicXML files, and it can also
 import from Capella and several other programs. MuseScore can export to
 PDF, PNG, and other graphic formats, to WAV and other audio formats such
 as OGG Vorbis and MP3, or to GNU Lilypond for an alternative layout and
 print option.
 .
 MuseScore can upload scores to musescore.com, a score sharing site, and
 send scrolling sheet music videos to YouTube. In addition to the desktop
 software, you can rehearse “on the go” with MuseScore mobile apps (which
 do not support note entry, but many advanced playback functions). Note
 that all of these are commercial or otherwise non-free offers optionally
 integrated with, but not part of, the Free notation program. Scrolling
 video scores feature the notes highlighted in the score as they sound —
 and highlighted on a virtual piano keyboard below.

=== debian/rules ===
#!/usr/bin/make -f

CWD:=$(abspath .)

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

MSPPKG=musescore3
MSCPKG=${MSPPKG}-common
MSPDIR=debian/${MSPPKG}
MSCDIR=debian/${MSCPKG}
MSHARE=usr/share/mscore3-*

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=

# unclutter build log; these are upstream’s to fix
OUR_CPPFLAGS+=	-Wno-deprecated-declarations
OUR_CPPFLAGS+=	-Wno-deprecated-copy

# only needed when backporting to buster and older
#OUR_LDFLAGS+=	-Wl,--as-needed

# defined for most of the code anyway; doing this here helps the PCH
OUR_CPPFLAGS+=	-DQT_NO_DEBUG
# avoid stray debugging output
OUR_CPPFLAGS+=	-DNDEBUG
# disable phoning home
OUR_CPPFLAGS+=	-DMSCORE_NO_UPDATE_CHECKER

# better debugging if requested
ifneq (,$(findstring optdbg,${DEB_BUILD_OPTIONS}))
OUR_CFLAGS+=	-Og -g3
OUR_CXXFLAGS+=	-Og -g3
endif

# things that cannot be passed via CPPFLAGS
OUR_CPPFLAGS+=	-I${CWD}/debian/q-include

dpkgbuildflagsmkescape=$(subst \,\\\,$(1))
export DEB_BUILD_MAINT_OPTIONS:=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CPPFLAGS})
export DEB_CFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CFLAGS})
export DEB_CXXFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CXXFLAGS})
export DEB_LDFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_LDFLAGS})
include /usr/share/dpkg/buildflags.mk
ifneq (,$(wildcard /usr/share/dpkg/buildtools.mk))
include /usr/share/dpkg/buildtools.mk
endif
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

CMAKE_DEFS:=	-DCMAKE_SKIP_RPATH=ON
CMAKE_DEFS+=	-DDOWNLOAD_SOUNDFONT=OFF
CMAKE_DEFS+=	-DUSE_SYSTEM_FREETYPE=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/
CMAKE_DEFS+=	-DBUILD_WEBENGINE=OFF
CMAKE_DEFS+=	-DOMR=ON
CMAKE_DEFS+=	-DUSE_SYSTEM_POPPLER=ON
CMAKE_DEFS+=	-DBUILD_CRASH_REPORTER=OFF

ifneq (linux,${DEB_HOST_ARCH_OS})
CMAKE_DEFS+=	-DBUILD_PORTMIDI=OFF
endif

CMAKE_DEFS+=	-DMSCORE_INSTALL_SUFFIX="3"

override_dh_auto_configure:
	rm -rf debian/q-include
	mkdir debian/q-include
	printf '#define DEB_PKG_VERSION "%s (%s %s/%s)"\n' \
	    $(call shellescape,${DEB_VERSION}) \
	    "$$(lsb_release -si)" \
	    "$$(lsb_release -sc)" \
	    $(call shellescape,${DEB_HOST_ARCH}) \
	    >debian/q-include/DEB_PKG_VERSION.h
	exec dh_auto_configure -- ${CMAKE_DEFS}

override_dh_auto_build:
	env GNUMAKEFLAGS="$$GNUMAKEFLAGS --output-sync" \
	    dh_auto_build -- lrelease all
	doxygen Doxyfile.plugins

override_dh_auto_test:
	exec mksh debian/buildtest ${DEB_BUILD_OPTIONS}

execute_after_dh_install-indep:
	# add doxygen-generated files
	cd doc && exec cp -r plugins ../${MSCDIR}/${MSHARE}/manual/
	dh_doxygen -p${MSCPKG} $$(cd ${MSCDIR} && \
	    echo ${MSHARE}/manual/plugins/html)
	# doc-base insists on /usr/share/doc/ prefix
	mkdir -p ${MSCDIR}/usr/share/doc/${MSCPKG}
	ln -sfTr ${MSCDIR}/${MSHARE}/manual/plugins \
	    ${MSCDIR}/usr/share/doc/${MSCPKG}/plugin-doxy
	# make system-wide soundfonts available
	cd ${MSCDIR}/${MSHARE} && mkdir -p sound && \
	    ln -sf ../../sounds/sf2 ../../sounds/sf3 ../../sounds/sfz sound/

execute_after_dh_auto_clean:
	rm -rf debian/q-include
	# remove possible doxygen remnants
	rm -rf doc/plugins
	-chmod -R g-w . # work around #796257 for Debian reproducible-builds
